searchNodes=[{"type":"module","title":"JsonSerde","doc":"A Json Serialization/Deserialization library that aims to create json documents from any nested data structures and deserialize json documents back to same datastructure. iex(1)&gt; map = %{ &quot;name&quot; =&gt; &quot;Joe&quot; , &quot;age&quot; =&gt; 21 , &quot;birthdate&quot; =&gt; Date . new ( 1970 , 1 , 1 ) |&gt; elem ( 1 ) } %{ &quot;age&quot; =&gt; 21 , &quot;birthdate&quot; =&gt; ~D[1970-01-01] , &quot;name&quot; =&gt; &quot;Joe&quot; } iex(2)&gt; { :ok , serialized } = JsonSerde . serialize ( map ) { :ok , &quot;{&quot; age &quot;:21,&quot; birthdate &quot;:{&quot; __data_type__ &quot;:&quot; date &quot;,&quot; value &quot;:&quot; 1970 - 01 - 01 &quot;},&quot; name &quot;:&quot; Joe &quot;}&quot; } iex(3)&gt; JsonSerde . deserialize ( serialized ) { :ok , %{ &quot;age&quot; =&gt; 21 , &quot;birthdate&quot; =&gt; ~D[1970-01-01] , &quot;name&quot; =&gt; &quot;Joe&quot; } } Custom structs can be marked with an alias, so resulting json does not appear elixir specific iex(2)&gt; defmodule CustomStruct do ...(2)&gt; use JsonSerde , alias : &quot;custom&quot; ...(2)&gt; defstruct [ :name , :age ] ...(2)&gt; end { :module , CustomStruct , &lt;&lt; 70 , 79 , 82 , 49 , 0 , 0 , 5 , 240 , 66 , 69 , 65 , 77 , 65 , 116 , 85 , 56 , 0 , 0 , 0 , 189 , 0 , 0 , 0 , 18 , 19 , 69 , 108 , 105 , 120 , 105 , 114 , 46 , 67 , 117 , 115 , 116 , 111 , 109 , 83 , 116 , 114 , 117 , 99 , 116 , 8 , 95 , 95 , ... &gt;&gt; , % CustomStruct { age : nil , name : nil } } iex(3)&gt; c = % CustomStruct { name : &quot;eddie&quot; , age : 34 } % CustomStruct { age : 34 , name : &quot;eddie&quot; } iex(4)&gt; { :ok , serialized } = JsonSerde . serialize ( c ) { :ok , &quot;{&quot; age &quot;:34,&quot; name &quot;:&quot; eddie &quot;,&quot; __data_type__ &quot;:&quot; custom &quot;}&quot; } iex(5)&gt; JsonSerde . deserialize ( serialized ) { :ok , % CustomStruct { age : 34 , name : &quot;eddie&quot; } } Supported Types Map List MapSet Tuple Atom Date DateTime NaiveDateTime Time Custom Structs Custom Structs The type key included in all structs is defaulted to &quot; data_type &quot; but can be customized by: config :json_serde , :type_key , &quot;type&quot; Note: This configuration is only read at compile time","ref":"JsonSerde.html"},{"type":"macro","title":"JsonSerde.data_type_key/0","doc":"","ref":"JsonSerde.html#data_type_key/0"},{"type":"function","title":"JsonSerde.deserialize/1","doc":"","ref":"JsonSerde.html#deserialize/1"},{"type":"function","title":"JsonSerde.deserialize!/1","doc":"","ref":"JsonSerde.html#deserialize!/1"},{"type":"function","title":"JsonSerde.serialize/1","doc":"","ref":"JsonSerde.html#serialize/1"},{"type":"function","title":"JsonSerde.serialize!/1","doc":"","ref":"JsonSerde.html#serialize!/1"},{"type":"type","title":"JsonSerde.serialized_term/0","doc":"A Json representation of the given term","ref":"JsonSerde.html#t:serialized_term/0"},{"type":"module","title":"JsonSerde.Alias","doc":"","ref":"JsonSerde.Alias.html"},{"type":"function","title":"JsonSerde.Alias.from_alias/1","doc":"","ref":"JsonSerde.Alias.html#from_alias/1"},{"type":"function","title":"JsonSerde.Alias.setup_alias/2","doc":"","ref":"JsonSerde.Alias.html#setup_alias/2"},{"type":"function","title":"JsonSerde.Alias.to_alias/1","doc":"","ref":"JsonSerde.Alias.html#to_alias/1"},{"type":"protocol","title":"JsonSerde.Deserializer","doc":"","ref":"JsonSerde.Deserializer.html"},{"type":"function","title":"JsonSerde.Deserializer.deserialize/2","doc":"","ref":"JsonSerde.Deserializer.html#deserialize/2"},{"type":"type","title":"JsonSerde.Deserializer.t/0","doc":"All the types that implement this protocol.","ref":"JsonSerde.Deserializer.html#t:t/0"},{"type":"protocol","title":"JsonSerde.Serializer","doc":"","ref":"JsonSerde.Serializer.html"},{"type":"function","title":"JsonSerde.Serializer.serialize/1","doc":"","ref":"JsonSerde.Serializer.html#serialize/1"},{"type":"type","title":"JsonSerde.Serializer.t/0","doc":"All the types that implement this protocol.","ref":"JsonSerde.Serializer.html#t:t/0"}]